package com.suribada;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.velocity.context.Context;
import org.apache.velocity.Template;
import org.apache.velocity.servlet.VelocityServlet;
import com.suribada.action.*;

public class ControllerServlet extends VelocityServlet {
	
	private String path;
	
    public Template handleRequest(HttpServletRequest request, HttpServletResponse response, Context ctx) {
    	path = getServletContext().getRealPath("/") + "files";
        Template template = null;
        String templateName = null;
   		String contentType = request.getContentType();       
        try {
        	//  ε   ó	
	  		if ((contentType != null) && (contentType.startsWith("multipart/form-data"))) {
				templateName = processMultipartRequest(request, response, ctx);
	  		} else {
	  			templateName = processRequest(request, response, ctx);
	  		}
            template  = getTemplate( templateName );
        } catch(Exception e) {
            System.out.println("Error handling the request: " + e);
        }
        return template;
    }
 
     
    private String processRequest(HttpServletRequest request, HttpServletResponse response, Context context)
     	throws Exception 
    {
        Command c = null;
        String template = null;
 
   		request.setCharacterEncoding("euc-kr");
        String action = request.getParameter("action");
        System.out.println("action: " + action);
        if (action == null || action.equals("") || action.equals("list")) {
            c = new ListCommand( request, response);
            template = c.exec(context);
        } else if (action.equals("insert")) {
        	c = new InsertCommand(request, response);
        	template = c.exec(context);
        } else if (action.equals("modify")) {
            c = new ModifyCommand(request, response);
            template = c.exec(context);
        } else if (action.equals("reply")) {
            c = new ReplyCommand(request, response);
            template = c.exec(context);
        } else if (action.equals("delete")) {
            c = new DeleteCommand(request, response);
            c.setPath(path);
            template = c.exec(context);
        } else if (action.equals("view")) {
            c = new ViewCommand(request, response);
            template = c.exec(context);
        }
        return template;
    }
    
 	private String processMultipartRequest(HttpServletRequest request, HttpServletResponse response, Context context)
     	throws Exception 
    {
 	   	Command c = new PostMutipartCommand(request, response);
  	  	c.setPath(path);
	  	String template = c.exec(context);
	  	return template;       	
    }

}
