package com.suribada.action;

import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.velocity.context.Context;
import com.suribada.ForumConstant;
import com.suribada.om.Message;
import com.suribada.om.ForumDAO;
import com.suribada.om.ForumDAOFactory;
import com.suribada.util.Formatter;

public class ListCommand extends Command {
	
    public static final String LIST = "list.vm";
    
 	public static final int itemRange = 10;	// ׸,
	public static final int pageRange = 10;  //    
	
    public ListCommand(HttpServletRequest request, HttpServletResponse response) {
        super(request, response);
    }
    
    public String exec(Context ctx) {
		String pageLink = null;
		ArrayList list = null;
		String condition = "";
		int cpage = 1;
		int totalPage = 1;	// ü 
		if (request.getParameter("cpage") != null && !request.getParameter("cpage").equals("")) {
			cpage = Integer.parseInt(request.getParameter("cpage"));
		}
    	String keyfield = request.getParameter("keyfield");
    	String keyword = request.getParameter("keyword");		
		if (keyword != null && keyword.length() > 0) {
			if (keyfield.equals("all")) {
				condition = " WHERE (name like '%" + keyword + "%' OR title like '%" + keyword + "%' OR content like '%" + keyword + "%')";
			} else {
				condition = " WHERE " + keyfield + " LIKE '%" + keyword + "%'";
			}	
		}	
		System.out.println("condition: " + condition);
		try {
			ForumDAO dao = ForumDAOFactory.getDAO(ForumConstant.FORUM_DBTYPE);
			int totalCnt = dao.countMessage(condition);
			int virtualCnt = totalCnt-pageRange * (cpage-1);
			System.out.println("totalCnt: " + totalCnt);
			if (totalCnt > 0) { // ش Խù  ٸ   ʴ´.
				totalPage = (int) Math.ceil((double)totalCnt / (double)itemRange);
				list = dao.getMessageList(cpage, itemRange, totalCnt, condition);
				pageLink = getPageLink(cpage, totalPage);
			}
			ctx.put("format", new Formatter());
			ctx.put("cpage", new Integer(cpage));
			ctx.put("totalPage", new Integer(totalPage));
			ctx.put("totalCnt", new Integer(totalCnt));
			ctx.put("virtualCnt", new Integer(virtualCnt));
			ctx.put("list", list);		
			ctx.put("pageLink", pageLink);
		} catch (Exception e) {
			e.printStackTrace();
    		ctx.put("message", e.getMessage());
    		return ERROR;
		}		
		return LIST;
    }
    
	private String getPageLink(int cpage, int totalPage) {
		String fblock = "<<-";
		String pblock = "<-";
		String token = "|";
		String nblock = "->";
		String lblock = "->>";
		StringBuffer buffer = new StringBuffer();
		int dest_page; //ũǴ 
   		int total_block = (int) Math.ceil((double) totalPage / (double) pageRange); //ü  
   		int block = (int) Math.ceil((double) cpage / (double) pageRange); // 
   		int first_page = (block-1) * pageRange;
   		int last_page = block * pageRange;

   		if (total_block <= block) {
      		last_page = totalPage;
   		}

   		if (block > 1) {
   			buffer.append("<a href=\"javascript:pageLink('1')\">" + fblock + "</a>");
      		dest_page = first_page;
   			buffer.append("<a href=\"javascript:pageLink('" + dest_page + "')\">" + pblock + "</a>");
		}
		//  ȣ ũ
   		for (int direct_page = first_page+1; direct_page <= last_page; direct_page++) {
   			if (direct_page == first_page+1) {
   				buffer.append("&nbsp;");
   			} else {
   				buffer.append(token);
   			}
   						
      		if (cpage == direct_page) {
      			buffer.append(cpage);
      		} else {
   				buffer.append("<a href=\"javascript:pageLink('" + direct_page + "')\">" + direct_page + "</a>");
      		}
	
			if (direct_page == last_page) {
				buffer.append("&nbsp;");
			}
		}
		
		//    Ͽ   ũ
   		if (block < total_block) {
      		dest_page = last_page+1;
   			buffer.append("<a href=\"javascript:pageLink('" + dest_page + "')\">" + nblock + "</a>");
   			buffer.append("<a href=\"javascript:pageLink('" + totalPage + "')\">" + lblock + "</a>");
		}
		return buffer.toString();
	}
	
}

