package com.suribada.action;

import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.velocity.context.Context;
import com.suribada.ForumConstant;
import com.suribada.om.Message;
import com.suribada.om.ForumDAO;
import com.suribada.om.ForumDAOFactory;
import com.suribada.util.Formatter;

public class ViewCommand extends Command {
	
    public static final String VIEW = "view.vm";
    
    public ViewCommand(HttpServletRequest request, HttpServletResponse response) {
        super(request, response);
    }

    public String exec(Context ctx) { 	
		ArrayList list = null;
		int recno = Integer.parseInt(request.getParameter("recno"));
		int fid = Integer.parseInt(request.getParameter("fid"));		
		try {
			ForumDAO dao = ForumDAOFactory.getDAO(ForumConstant.FORUM_DBTYPE);
			list = dao.getMessageGroup(recno, fid);
			ctx.put("format", new Formatter());
			ctx.put("list", list);		
		} catch (Exception e) {
			e.printStackTrace();
    		ctx.put("message", e.getMessage());
    		return ERROR;
		}		   
        return VIEW;
    }
    
}


