package com.suribada.util;

import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * JNDI ͼҽ ͺ̽ Ŀؼ  ޼ҵ ͺ̽ ڿ ݳϴ ޼ҵ 
 *
 * ex)
 * DBResource db = new DBResource();
 * Connection con = db.getConnection("java:comp/env/jdbc/bookshop");
 * ....
 * db.close(rs, stmt, con);
 */

public class DBResource {
	
	/**
	 * Ÿҽ JNDI Ŀؼ ü  ޼ҵ 
	 * @param dsName Ÿҽ JNDI
	 */
	public Connection getConnection(String dsName) throws NamingException, SQLException {
		Context context = new InitialContext();
		DataSource ds = (DataSource) context.lookup(dsName);
		return ds.getConnection();
	}
	
	/**
	 * Ÿ̽ ڿ ݳϴ ޼ҵ
	 */
	public void close(ResultSet rs, Statement stmt, Connection con) {
		try {
			if (rs != null) {
				rs.close();
			}
			if (stmt != null) {
				stmt.close();
			}
			if ((con != null) && (!con.isClosed())) {
				con.close();
			}
		} catch (SQLException e) {
			System.out.println(e.toString());
		}	
	}

}
